unit plugin;

interface

function InitPlugin(CallBack:pointer):boolean; stdcall;
function GetPluginControls(var chars:shortstring):boolean; stdcall;
function PluginTimer(Time:cardinal;Display:boolean):boolean; stdcall;
function PluginControl(chr:char;Time:cardinal):boolean; stdcall;

implementation

const //display plugin flags
     PIF_SHOWHHMMSS=1;
     PIF_BLINKSEC1=2;
     PIF_BLINKSEC2=4;
     PIF_BLINKMIN1=8;
     PIF_BLINKMIN2=16;
     PIF_BLINKHOUR1=32;
     PIF_BLINKHOUR2=64;
     PIF_BLINKDOTS=128;
     PIF_BLINKALL=$fe;

var PluginCallback:function(time:cardinal;flags:cardinal;Str:shortstring):longint; stdcall;
    Start,Current:cardinal;
    mode:byte;
    Disp:boolean;
    splittime:cardinal;


{function DesumTime(time1,time2:cardinal):cardinal;
var t:cardinal;
begin
  t:=time1-time2;
  if (t and $ff)>100 then t:=(t + $64) and $ff + t and $ffffff00;
  if ((t shr 8) and $ff)>59 then t:=(t + $3c00)and $ff00 + t and $ffff00ff;
  if ((t shr 16) and $ff0000)>59 then t:=(t + $3c0000)and $ff0000 + t and $ff00ffff;
  if ((t shr 24) and $ff000000)>24 then t:=(t + $18000000)and $ff000000 + t and $00ffffff;
  result:=t;
end;}

function DesumTime(time1,time2:cardinal):cardinal;
type castype=record
              hour,min,sec,milisec:word;
             end;
var i:integer;
    a,b,c:castype;
begin
 a.hour:=(time1 shr 24) and $ff;
 a.min:=(time1 shr 16) and $ff;
 a.sec:=(time1 shr 8) and $ff;
 a.milisec:=time1 and $ff;
 b.hour:=(time2 shr 24) and $ff;
 b.min:=(time2 shr 16) and $ff;
 b.sec:=(time2 shr 8) and $ff;
 b.milisec:=time2 and $ff;

 i:=a.milisec-b.milisec;
 if i>=0 then c.milisec:=a.milisec-b.milisec
                             else begin c.milisec:=100+a.milisec-b.milisec; inc(b.sec) end;
 i:=a.sec-b.sec;
 if i>=0 then c.sec:=a.sec-b.sec
                             else begin c.sec:=60+a.sec-b.sec; inc(b.min) end;
 i:=a.min-b.min;
 if i>=0 then c.min:=a.min-b.min
                             else begin c.min:=60+a.min-b.min; inc(b.hour) end;
 i:=a.hour-b.hour;
 if i>=0 then c.hour:=a.hour-b.hour
                             else begin c.hour:=24+a.hour-b.hour end;
 result:=c.hour shl 24 + c.min shl 16 + c.sec shl 8 + c.milisec;
end;

function InitPlugin(CallBack:pointer):boolean;
begin
  PluginCallback:=callback;
  Start:=0;
  Current:=0;
  mode:=0;
  disp:=false;
  result:=true;
end;

function GetPluginControls(var chars:shortstring):boolean;
begin
  chars:='/*';
  result:=true;
end;

function PluginTimer(Time:cardinal;Display:boolean):boolean;
begin
  case mode of
    0: if display then plugincallback(0,0,'');
    1: begin
         current:=desumtime(Time,Start);
         if display then
                if not disp then plugincallback(current,0,'Stopwatch')
                            else plugincallback(current,0,'');
       end;
    2: begin
         if display then
                     if not disp then plugincallback(current,0,'Stopwatch (paused)')
                                 else plugincallback(current,0,'');
       end;
  end;
  disp:=display;
  result:=true;
end;

function PluginControl(chr:char;Time:cardinal):boolean;
begin
  case chr of
    '/',#2: begin
            case mode of
              0: begin Start:=Time; mode:=1; end;
              1: begin Current:=desumtime(time,start); if disp then plugincallback(current,0,'Stopwatch (paused)'); mode:=2; end;
              2: begin Start:=desumtime(time,current); if disp then plugincallback(current,0,'Stopwatch'); mode:=1; end;
              3: begin if disp then plugincallback(current,0,'Stopwatch (split&paused)'); Current:=desumtime(time,start); mode:=4; end;
              4: begin Start:=desumtime(time,current); if disp then plugincallback(splittime,PIF_BLINKDOTS,'Stopwatch (split)'); mode:=3; end;
            end;
         end;
    '*',#1: begin
            case mode of
              1: begin Current:=desumtime(time,start); splittime:=current; if disp then plugincallback(current,PIF_BLINKDOTS,'Stopwatch (split)'); mode:=3; end;
              2: begin Current:=0; if disp then plugincallback(0,0,'Stopwatch'); mode:=0; end;
              3: begin Current:=desumtime(time,start); if disp then plugincallback(current,0,'Stopwatch'); mode:=1; end;
              4: begin if disp then plugincallback(current,0,'Stopwatch (paused)'); mode:=2; end;
            end;
         end;
  end;
  result:=true;
end;

end.
